kinetic = (I0x*(vroll0 - vyaw0*Sin[pitch0])^2 + 
       I0z*(vyaw0*Cos[pitch0]*Cos[roll0] - vpitch0*Sin[roll0])^2 + 
       I0y*(vpitch0*Cos[roll0] + vyaw0*Cos[pitch0]*Sin[roll0])^2)/2 + 
     (m0*((Cos[pitch0]*Cos[roll0]*Dt[COMz, t] - COMx*Cos[pitch0]*
           Dt[pitch0, t] + COMy*Cos[pitch0]*Cos[roll0]*Dt[roll0, t] + 
          Dt[z0, t] - Dt[COMx, t]*Sin[pitch0] - COMz*Cos[roll0]*Dt[pitch0, t]*
           Sin[pitch0] + Cos[pitch0]*Dt[COMy, t]*Sin[roll0] - 
          COMz*Cos[pitch0]*Dt[roll0, t]*Sin[roll0] - COMy*Dt[pitch0, t]*
           Sin[pitch0]*Sin[roll0])^2 + (Dt[y0, t] + COMx*Cos[pitch0]*
           Cos[yaw0]*Dt[yaw0, t] + Cos[pitch0]*Dt[COMx, t]*Sin[yaw0] - 
          COMx*Dt[pitch0, t]*Sin[pitch0]*Sin[yaw0] + Dt[COMz, t]*
           (-(Cos[yaw0]*Sin[roll0]) + Cos[roll0]*Sin[pitch0]*Sin[yaw0]) + 
          COMy*(-(Cos[yaw0]*Dt[roll0, t]*Sin[roll0]) + Cos[yaw0]*Dt[yaw0, t]*
             Sin[pitch0]*Sin[roll0] - Cos[roll0]*Dt[yaw0, t]*Sin[yaw0] + 
            Cos[roll0]*Dt[roll0, t]*Sin[pitch0]*Sin[yaw0] + 
            Cos[pitch0]*Dt[pitch0, t]*Sin[roll0]*Sin[yaw0]) + 
          Dt[COMy, t]*(Cos[roll0]*Cos[yaw0] + Sin[pitch0]*Sin[roll0]*
             Sin[yaw0]) + COMz*(-(Cos[roll0]*Cos[yaw0]*Dt[roll0, t]) + 
            Cos[roll0]*Cos[yaw0]*Dt[yaw0, t]*Sin[pitch0] + 
            Cos[pitch0]*Cos[roll0]*Dt[pitch0, t]*Sin[yaw0] + 
            Dt[yaw0, t]*Sin[roll0]*Sin[yaw0] - Dt[roll0, t]*Sin[pitch0]*
             Sin[roll0]*Sin[yaw0]))^2 + (Cos[pitch0]*Cos[yaw0]*Dt[COMx, t] + 
          Dt[x0, t] - COMx*Cos[yaw0]*Dt[pitch0, t]*Sin[pitch0] - 
          COMx*Cos[pitch0]*Dt[yaw0, t]*Sin[yaw0] + Dt[COMy, t]*
           (Cos[yaw0]*Sin[pitch0]*Sin[roll0] - Cos[roll0]*Sin[yaw0]) + 
          COMz*(Cos[pitch0]*Cos[roll0]*Cos[yaw0]*Dt[pitch0, t] + 
            Cos[yaw0]*Dt[yaw0, t]*Sin[roll0] - Cos[yaw0]*Dt[roll0, t]*
             Sin[pitch0]*Sin[roll0] + Cos[roll0]*Dt[roll0, t]*Sin[yaw0] - 
            Cos[roll0]*Dt[yaw0, t]*Sin[pitch0]*Sin[yaw0]) + 
          Dt[COMz, t]*(Cos[roll0]*Cos[yaw0]*Sin[pitch0] + 
            Sin[roll0]*Sin[yaw0]) + COMy*(-(Cos[roll0]*Cos[yaw0]*
              Dt[yaw0, t]) + Cos[roll0]*Cos[yaw0]*Dt[roll0, t]*Sin[pitch0] + 
            Cos[pitch0]*Cos[yaw0]*Dt[pitch0, t]*Sin[roll0] + 
            Dt[roll0, t]*Sin[roll0]*Sin[yaw0] - Dt[yaw0, t]*Sin[pitch0]*
             Sin[roll0]*Sin[yaw0]))^2))/2
 
kinetic /: kinetic::usage = "kinetic is part of the specification of the \
model. It should be an expression for the kinetic energy in terms of \
derivatives of the variables (e.g., Dt[x1,t])."
 
I0x /: I0x::usage = "I0x is x-axis MOI of optic."
 
I0z /: I0z::usage = "I0z is z-axis MOI of optic."
 
I0y /: I0y::usage = "I0y is y-axis MOI of optic."
 
m0 /: m0::usage = "m0 is mass of optic."
